unit cxdmain;

interface

uses Forms, Windows, Graphics, Classes, Controls, StdCtrls, Buttons, ComCtrls,
  ToolWin, ExtCtrls, ImgList, CheckLst, cxdframe {cxdconsts};
type
  Tf0 = class(TForm)
    Label1: TLabel;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    sbStop: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure btOpenClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckListBox1ClickCheck(Sender: TObject);
    procedure ckColorClick(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure HeaderControl1DrawSection(HeaderControl: THeaderControl;
      Section: THeaderSection; const Rect: TRect; Pressed: Boolean);
    procedure HeaderControl1SectionClick(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure sbSettingsClicked(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure sbProceedClicked(Sender: TObject);
    procedure sbStopClicked(Sender: TObject);
    procedure CheckListBox1Exit(Sender: TObject);
  private
    procedure CreateLabelNames;
    procedure CreateCheckListBoxes;
    procedure CreateCheckBoxes;
    procedure CreateLabelProductReturns;
    procedure CreateComponents;
  private
    procedure init;
  private
    OldColor: TColor;
    funColorEnabled: boolean;
    procedure RepaintAllFrames(Colour: Tcolor);
    procedure RepaintButtondAndStatus(Colour: Tcolor);
    procedure DepaintControls(FunColor: boolean);
    property Colorize: boolean read funColorEnabled write DepaintControls;
    function RandomColorFrame: TColor;
    function RandomColorHeader: TColor;
    function RandomColorDetail: TColor;
    procedure FramesAreaClicked(Sender: TObject);
    procedure ColumnAreaClicked(Sender: TObject);
    procedure DetailsAreaClicked(Sender: TObject);
    procedure showcolorstatus(colour: TColor);
  private
    //procedure EnumControls(Component: TComponent; Strings: TStrings);
    //procedure EnumComponents(Component: TComponent; Strings: TStrings);
    //procedure EnumComponentProperties(Component: TComponent; Strings: TStrings);
  private
    procedure EnableControls(const enable: boolean);
    procedure BreakUp(const breakit: boolean);
    procedure SetInProgress(const processing: boolean);
  private
    fBroken: boolean;
    fInprogress: boolean;
    //procedure ShowStatus(const index: integer; const Contestant: TContestant;
    //  methode: TMethode; LoopCounter: integer);
    procedure ShowStatus(const indexes: array of byte; const Messages: array of string;
      const Referesh: boolean = FALSE);
    property InProgress: boolean read fInProgress write SetInProgress;
    property Broken: boolean read fBroken write BreakUp;
  private
    tickHz: int64;
    //EnabledOntestant & CheckedMethodes
    procedure GetStatistics;
    procedure ShowGlobalSettings; // display globalsettings
    procedure StoreDisplayedSettings; // store displayed settings to globalsettings
  public

  end;

var
  f0: Tf0;

implementation

{$R *.DFM}
uses
  SysUtils, Dialogs, Spin, ClipBrd, TypInfo,
  cxdconsts, cxdfindop, cxdftest, cxdfuncs
  ;

resourcestring
  colorme = 'Double-Click to change color...';

type
  TMargin = (tmTop, tmLeft, tmBottom, tmContestant);

  TTitleLabels = packed array[TReturn] of TLabel;
  TTitleSections = packed array[TReturn] of THeaderSection;
  TMarginLabels = packed array[TMargin] of TLabel;

  TProductLabels = packed array(.TContestant, TMethode.) of TLabel;
  TProductReturnValues = packed array(.TReturn, TContestant, TMethode.) of integer;
  TProductReturnLabels = packed array(.TReturn, TContestant, TMethode.) of TLabel;
  //TProductCheckBoxes = packed array(.TContestant, TMethode.) of TCheckBox;
  TContestantCheckListBoxes = packed array[TContestant] of TCheckListBox;

var
  LabelTitles: TTitleLabels;
  ProductReturnValues: TProductReturnValues;
  //LabelResults, LabelTimeTotals, LabelTimeAverages, LabelPerfRatios: TProductLabels;
  LabelProductReturns: TProductReturnLabels;
  ContestantCheckListBoxes: TContestantCheckListBoxes;
  LabelMargins: TMarginLabels;
  HeaderTitles: THeaderControl;

var
  Dashboard: TPanel;
  StatusBar: TStatusBar;
  btOpen: TSpeedButton; //TColorButton;
  ScrollBox: TScrollBox;
  CheckBox: TCheckBox; // th first.checkbox
  OpenDialog: TOpenDialog;
  ckColor: TCheckBox;

type
  tLabelStatus = (stNone, stNormal, stChecked, stDisabled, stCheckedDisabled, stInProgress); //,
  //stxSlowest, stxSlower, stxSlow, stxMedium, stxFast, stxFaster, stxFastest);

const
  lcfNone = clNone;
  lcfNormal = clWindowText;
  lcfUnchecked = clSilver; //lcfNormal;
  lcfChecked = lcfNormal;
  lcfDisabled = clGray;
  lcfCheckedDisabled = lcfDisabled;
  lcfInProgress = lcfNormal;
  lcfFastestChecked = clRed;
  lcfFastestUnchecked = clMaroon;

  lbgParent = $2D0D0D0; //clBtnFace;
  lbgNone = clNone;
  lbgNormal = lbgParent;
  lbgChecked = lbgParent; //clAqua;
  lbgDisabled = $2CCCCCC; //$2C8C8C8;
  lbgCheckedDisabled = lbgDisabled; //$2A0D0D0;
  lbgInProgress = clAqua;

  lfsNormal = [];
  lfsUnchecked = lfsNormal;
  lfsChecked = [];
  lfsDisabled = [fsStrikeOut];
  lfsCheckedDisabled = [];
  lfsInProgress = lfsChecked;

  //clrBGPerfRatio = clFuchsia;
  clrFGPerfRatio = clBlue;

const
  LabelStatusBGColors: array[tLabelStatus] of tColor =
  (lbgNone, lbgNormal, lbgChecked, lbgDisabled, lbgCheckedDisabled, lbgInProgress); //,
  //lbgNormal, lbgNormal, lbgNormal, lbgNormal, lbgNormal, lbgNormal, lbgNormal);

  LabelStatusFontColors: array[tLabelStatus] of tColor =
  (lcfNone, lcfUnchecked, lcfChecked, lcfDisabled, lcfCheckedDisabled, lcfInProgress); //,
  //lcfNormal, lcfNormal, lcfNormal, lcfNormal, lcfNormal, lcfNormal, lcfNormal);

  LabelStatusFontStyles: array[tLabelStatus] of tFontStyles =
  ([], lfsNormal, lfsChecked, lfsDisabled, lfsCheckedDisabled, lfsInProgress); //,
  //[], [], [], [], [], [], []);

  idsProgress = 0;
  idsLoopCounter = 0;
  idsContestant = 1;
  idsMethod = 2;
  idsSubStr = 3;
  idsReplacement = 4;
  idsCaseOption = 5;
  idsWorkingFile = 6;

procedure SyncContestantLabels(const Contestant: TContestant;
  const methode: TMethode; const Status: tLabelStatus); overload;
var
  r: TReturn;
begin
// can you follow these :((, well I (who once ever cook this spaghetti), can't.
  for r := succ(low(r)) to high(r) do
    with LabelProductReturns[r, Contestant, methode] do
      if r = high(r) then with font do if Style * [fsBold] = [] then Style := Style + [fsBold]
          else else begin
            if Color <> LabelStatusBGColors[Status] then
              Color := LabelStatusBGColors[Status];
            with Font do begin
              if Color <> LabelStatusFontColors[Status] then
                Color := LabelStatusFontColors[Status];
              if Style <> LabelStatusFontStyles[Status] then
                Style := LabelStatusFontStyles[Status];
            end;
            case Status of
              stNormal: ;
              stChecked: ;
              stDisabled: ;
              stCheckedDisabled: ;
              stInProgress: ;
              else ;
            end;
          end;
end;

procedure SyncContestantLabels(const Contestant: TContestant; const methode: TMethode;
  const Enable: boolean; const Checked: boolean); overload; //Checked: boolean); overload;
var
  r: TReturn;
begin///
  if Checked then
    if Enable then
      SyncContestantLabels(Contestant, methode, stChecked)
    else
      SyncContestantLabels(Contestant, methode, stCheckedDisabled)
  else
    if Enable then
      SyncContestantLabels(Contestant, methode, stNormal)
    else
      SyncContestantLabels(Contestant, methode, stDisabled)
        ; ///
  for r := low(r) to high(r) do
    with LabelProductReturns[r, Contestant, methode] do
      if Enabled <> enable then Enabled := enable;
end;

//procedure SyncContestantLabels(const Contestant: TContestant; const enable: boolean); overload;
//var
//  r: TReturn; m: TMethode;
//begin
//  for r := low(r) to high(r) do
//    for m := low(m) to high(m) do
//      with LabelProductReturns[r, Contestant, m] do begin
//        if Enabled <> enable then
//          Enabled := enable;
//      end;
//end;

procedure SyncCheckListBox(const clb: TCheckListBox; const enable: boolean; SyncLabels: boolean = TRUE); overload;
var
  m: TMethode;
begin
  with clb do begin
    if Enabled <> enable then Enabled := enable;
    if enable and (ItemIndex >= 0) then ItemIndex := -1;
    if SyncLabels then
      for m := low(m) to high(m) do
        SyncContestantLabels(TContestant(clb.tag), m, Enabled, Checked[ord(m)]);
  end;
end;

procedure SyncCheckListBox(const c: TContestant; const enable: boolean; SyncLabels: boolean = TRUE); overload;
var
  clb: TCheckListBox;
begin
  clb := ContestantCheckListBoxes[c];
  SyncCheckListBox(clb, enable, SyncLabels);
end;

procedure Tf0.CheckBox1Click(Sender: TObject); // called by CreateCheckBoxes creation
begin
  with TCheckBox(Sender) do
    SyncCheckListBox(ContestantCheckListBoxes[TContestant(tag)], Checked);
end;

procedure Tf0.CreateCheckBoxes; // must be called after CreateCheckListBoxes
const
  DOT = '.';
  SPACE = ' ';
  DOTSPACE = DOT + SPACE;
var
  c: TContestant;
  CheckPoint: TPoint;
begin
  if ContestantCheckListBoxes[low(c)] = nil then
    raise exception.create('This procedure must be called after CreateCheckListBoxes');
  for c := low(c) to high(c) do
    with TCheckBox.Create(Self) do begin
      visible := FALSE;
      Parent := ScrollBox;
      Tag := ord(c);
      Hint := ContestantsDescription[c];
      ShowHint := YES;
      Height := 13;
      Cursor := crHandPoint;
      Caption := char(ord('0') + ord(c) + 1) + DOTSPACE + ContestantsName[c];
      Checked := TRUE;
      Left := LabelMargins[tmContestant].left;
      Top := ContestantCheckListBoxes[c].Top - abs(font.Height) - 4;
      with Font do Style := style + [fsBold];
      //Checked := c in GlobalSettings.EnabledContestants; //DefaultEnabledContestant;
      //SyncCheckListBox(c, Checked, FALSE);
      OnClick := CheckBox1Click;
      //color := LabelMargins[tmContestant].Color;
      if c = low(c) then
        with CheckPoint do begin
          x := Left + 1; y := Top + 1
        end;

      Tag := ord(c);
      visible := YES;
    end;
  CheckBox := TCheckBox(ScrollBox.ControlAtPos(CheckPoint, YES, YES));
  //showmessage(CheckBox.ClassName);
end;

procedure Tf0.CreateCheckListBoxes; // must be created earlier before any other controls
const
  //FIXED_WIDTH = LBLNAMES_WIDTH;
  //FIXED_TOPMARGIN = 20; //36;
  FIXED_LEFTMARGIN = 26;
  FIXED_ROWSPACER = 8;
const
  mx: TMethodes = [mtPosFile..mtReplaceFile];
  cx: TContestants = [ctAJSearch, ctcxpos];
var
  //i: integer;
  topmargin: integer;
  c: TContestant;
  m: TMethode;
  ml: TStringList;
  clb, CheckListBox: TCheckListBox;
  clbs: pointer absolute ContestantCheckListBoxes;
type
  tclbs = TContestantCheckListBoxes;
begin
  clbs := @ContestantCheckListBoxes;
  topmargin := HeaderTitles.Height;
  ml := tStringList.Create;
  try
    for m := low(m) to high(m) do
      ml.Add(MethodesName[m]);
    for c := low(c) to high(c) do begin
      CheckListBox := TCheckListBox.Create(Self);
      with CheckListBox do begin
        Visible := FALSE;
        Parent := ScrollBox;
        Tag := ord(c);
        BorderStyle := bsNone;
        ParentColor := YES;
        if c = low(c) then begin
          Top := topmargin;
          Left := FIXED_LEFTMARGIN;
          Width := LabelMargins[tmContestant].width - FIXED_LEFTMARGIN;
          //for m := low(TMethode) to high(TMethode) do
          //  Items.Add(MethodesName[m]);
          items.Assign(ml);
        end
        else begin
          clb := tclbs((@clbs)^)[pred(c)];
          Items.AddStrings(clb.Items);
          // Height := clb.Height;
          Width := clb.Width;
          Left := clb.left;
          Top := clb.Top + clb.Height + FIXED_ROWSPACER;
        end;
        // items.Assign(ml);
        // if not (c in cx) then
        //   with items do
        //     for m := mtPosFile to mtReplaceFile do
        //       Delete(Count - 1);
        //for i := 0 to items.count - 1 do
        //  Checked[i] := tmethode(i) in GlobalSettings.CheckedMethodes[c]; // DefaultCheckedMethodes[c];
        IntegralHeight := YES;
        Height := ItemHeight * (Items.Count + 1);
        Visible := YES;
        // color := tmyControl(Self.controls[0]).color;
        //Enabled := c in GlobalSettings.EnabledContestants; //DefaultEnabledContestant;
        OnClickCheck := CheckListBox1ClickCheck;
        OnExit := CheckListBox1Exit;
      end;
      tclbs((@clbs)^)[c] := CheckListBox;
    end;
  finally
    ml.Free;
  end;
end;

// type
//   tmyControl = class(tControl);

procedure Tf0.CreateLabelNames; // contains: CreateLabelMargins & CreateLabelTitles
const
  DEFAULT_LABEL_WIDTH = 100;
  LABEL_NAME = 'Unit/Component';

  procedure CreateHeaderTitles;
  var
    r: TReturn;
  begin
    HeaderTitles := THeaderControl.Create(Self);
    HeaderTitles.Style := hsFlat;
    HeaderTitles.Height := abs(font.height) * 2;
    HeaderTitles.Top := Height;
    HeaderTitles.Parent := Self;

    with HeaderTitles.Sections.Add do begin
      MinWidth := 29;
      MaxWidth := MinWidth;
      Style := hsOwnerDraw;
    end;
    with HeaderTitles.Sections.Add do begin
      Text := LABEL_NAME;
      MinWidth := DEFAULT_LABEL_WIDTH;
      MaxWidth := MinWidth;
      AutoSize := FALSE;
      Alignment := taCenter;
      Style := hsOwnerDraw;
      //Style := hsOwnerdraw;
    end;

    for r := low(r) to high(r) do begin
      with HeaderTitles.Sections.Add do begin
        Text := ReturnsCaption[r];
        case r of
          //high(TReturn):
          //rtResult: MinWidth := DEFAULT_LABEL_WIDTH * 4 div 5;
          rtPerfratio: MinWidth := DEFAULT_LABEL_WIDTH * 4 div 5;
          rtRank: MinWidth := DEFAULT_LABEL_WIDTH div 2;
          else
            MinWidth := DEFAULT_LABEL_WIDTH // + 20
        end;
        MaxWidth := MinWidth;
        AutoSize := FALSE;
        Alignment := taCenter;
        Style := hsOwnerDraw;
        //Style := hsOwnerdraw;
      end;
    end;
    HeaderTitles.OnDrawSection := HeaderControl1DrawSection;
    HeaderTitles.OnSectionClick := HeaderControl1SectionClick;
    //tWinControl(HeaderTitles).brush.color := clBlue;
    //tmyControl(HeaderTitles).ParentColor := TRUE;
  end;

  procedure CreateLabelMargins;
  const
    LABEL_NAME = 'Unit Name';
    DEFAULT_TOP_MARGIN = 8;
    DEFAULT_BOTTOM_MARGIN = 8;
    DEFAULT_LEFT_MARGIN = 8;
  var
    lbl: tlabel; m: Tmargin;
  begin
    for m := low(m) to high(m) do begin
      lbl := tlabel.Create(Self);
      with lbl do begin
        //color := tcolor($02808080 or random($FFFFFF));
        autosize := FALSE;
        tag := ord(m);
        case m of
          tmTop: begin
              height := DEFAULT_TOP_MARGIN;
              top := MaxInt; //Self.controls[0].Height;
              align := alTop;
            end;
          tmLeft: begin
              width := DEFAULT_LEFT_MARGIN;
              align := alLeft;
            end;
          tmBottom: begin
              height := DEFAULT_BOTTOM_MARGIN;
              top := 0;
              align := alBottom;
            end;
          else begin
              //Caption := LABEL_NAME;
              width := DEFAULT_LABEL_WIDTH + 20; // - 10;
              with font do style := style + [fsBold];
              left := Self.Width;
              align := alLeft;
            end;
        end;
        OnClick := FramesAreaClicked;
        if (m = tmTop) or (m = tmLeft) or (m = tmBottom) then Parent := Self
        else parent := ScrollBox;
      end;
      LabelMargins[m] := lbl;
    end;
  end;

  procedure CreateLabelTitles; //const EDGE_OFFSET = 10;
  const
    HEADER_NOTUSED_LEFT_SECTION_COUNT = 2;
  var
    lbl: tlabel; r: TReturn;
  begin
    for r := low(r) to high(r) do begin
      lbl := tlabel.Create(Self);
      with lbl do begin
        autosize := FALSE;
        tag := ord(r);
        width := HeaderTitles.Sections[ord(r) + HEADER_NOTUSED_LEFT_SECTION_COUNT].Width;
        //Caption := ReturnsCaption[r];
        //width := HeaderTitles.Sections[]//DEFAULT_LABEL_WIDTH;
        //with font do style := style + [fsBold];

        //
        // use code below if you want to set the last-one label to alClient
        // if r = high(TReturn) then align := alClient
        // else...

        // use code below if you want to set the second-last one label
        // to alClient, and the last one set to alRight
        // if r = high(TReturn) then align := alRight //alClient
        // else if r = pred(high(TReturn)) then align := alClient
        // else..

        begin
          left := Self.width;
          align := alLeft;
        end;
        //if (r = high(TReturn)) or (r = low(TReturn)) then
        //  Width := Width - EDGE_OFFSET;
        alignment := taCenter; // talign
        OnClick := ColumnAreaClicked;
        parent := ScrollBox;
        // should be put here after assigning parent,
        // to inherit the parent color before set to false
        ParentColor := FALSE;
      end;
      LabelTitles[r] := lbl;
    end;
  end;

begin
  CreateHeaderTitles;
  CreateLabelMargins;
  CreateLabelTitles;
end;

procedure Tf0.CreateLabelProductReturns;
var
  c: TContestant; m, n: TMethode; r: TReturn;
  lbl: TLabel;
  //pt: tPoint;
  rect: trect;
begin
  fillchar(LabelProductReturns, sizeof(LabelProductReturns), 0);
  for r := low(r) to high(r) do begin
    rect.Left := LabelTitles[r].left;
    rect.Right := LabelTitles[r].width;
    rect.Bottom := ContestantCheckListBoxes[low(TContestant)].ItemHeight;
    for c := low(c) to high(c) do begin
      n := TMethode(ContestantCheckListBoxes[c].Items.Count - 1);
      rect.Top := ContestantCheckListBoxes[c].Top;
      for m := low(m) to high(m) do begin
        if n < m then continue;
        lbl := TLabel.Create(Self);
        lbl.visible := FALSE;
        lbl.AutoSize := FALSE;
        lbl.Transparent := FALSE;
        lbl.Caption := '';
        lbl.Left := rect.Left;
        if (r = high(r)) then
          lbl.Alignment := taCenter
        else
          lbl.Alignment := taRightJustify;
        lbl.Width := rect.Right - 1;
        if m = low(n) then
          lbl.Top := rect.Top
        else
          lbl.Top := LabelProductReturns[r, c, pred(m)].Top + rect.Bottom;
        lbl.OnClick := DetailsAreaClicked;
        lbl.visible := YES;
        LabelProductReturns[r, c, m] := lbl;
        lbl.Parent := ScrollBox;
        lbl.Tag := EncodeProducts(r, c, m);
      end;
    end;
  end;
  //with GlobalSettings do
  //  for c := low(c) to high(c) do
  //    for m := low(m) to high(m) do
  //      SyncContestantLabels(c, m, c in EnabledContestants, m in CheckedMethodes[c]);

  //for c := low(c) to high(c) do
    //for m := low(m) to high(m) do
    //SyncContestantLabels(c, c in GlobalSettings.EnabledContestant);

  {
  //columnwise initialization
  for c := low(c) to high(c) do
    for m := low(m) to high(m) do
      LabelResults[c, m] := LabelProductReturns[rtResult, c, m];

  for c := low(c) to high(c) do
    for m := low(m) to high(m) do
      LabelTimeTotals[c, m] := LabelProductReturns[rtTimeTotal, c, m];

  for c := low(c) to high(c) do
    for m := low(m) to high(m) do
      LabelTimeAverages[c, m] := LabelProductReturns[rtTimeAverage, c, m];

  for c := low(c) to high(c) do
    for m := low(m) to high(m) do
      LabelPerfRatios[c, m] := LabelProductReturns[rtPerfRatio, c, m];
   }
end;

procedure Tf0.RepaintAllFrames(Colour: TColor);
begin
  with btOpen do if not ParentColor then ParentColor := TRUE;
  with statusbar do if not ParentColor then ParentColor := TRUE;
  showcolorstatus(Colour);
  Self.Color := Colour;
end;

type
  tmyControl = class(TControl);

procedure Tf0.RepaintButtondAndStatus(Colour: TColor);
var
  c: TContestant; m: TMethode;
begin
  // BeginPaint(handle,
  tmyControl(btOpen).Color := Colour;
  StatusBar.Color := Colour;
  showcolorstatus(Colour);
  for c := low(TContestant) to high(TContestant) do begin
    for m := low(TMethode) to high(TMethode) do begin
    end;
  end;
end;

procedure tf0.DepaintControls(FunColor: boolean);
var
  c: TContestant; m: TMethode; r: TReturn;
  i: integer;
  //  Colour: TColor;
begin
  if funColorEnabled <> FunColor then begin

    if not FunColor then begin
      Self.Enabled := FALSE;
      for i := 0 to ComponentCount - 1 do
        if Components[i] is tControl then
          with tmyControl(Components[i]) do
            ParentColor := YES;
      Self.Color := OldColor;

      //for r := low(TReturn) to high(TReturn) do
      //  LabelTitles[r].Color := OldColor;
      //RepaintAllFrames(OldColor);
      Self.Enabled := YES;
    end
    else begin
      OldColor := Self.Color;
      for r := low(TReturn) to high(TReturn) do
        LabelTitles[r].Color := RandomColorDetail;
      RepaintAllFrames(RandomColorHeader);
    end;
    for c := low(TContestant) to high(TContestant) do begin
      for m := low(TMethode) to high(TMethode) do begin
      end;
    end;
    funColorEnabled := FunColor;
  end;
end;

procedure Tf0.FramesAreaClicked(Sender: TObject);
begin
  if funColorEnabled then begin
    RepaintAllFrames(RandomColorFrame);
  end;
end;

procedure Tf0.ColumnAreaClicked(Sender: TObject);
var
  r: TReturn; c: TContestant; t: TMethode;
begin
  if funColorEnabled then begin
    with tmyControl(Sender) do begin
      Color := RandomColorHeader;
      r := treturn(tag);
      for c := low(TContestant) to high(TContestant) do
        for t := low(TMethode) to high(TMethode) do
          LabelProductReturns[r, c, t].Color := Color;
      RepaintButtondAndStatus(Color);
    end;
  end;
end;

procedure Tf0.DetailsAreaClicked(Sender: TObject);
begin
  if funColorEnabled then begin
    with tmyControl(Sender) do begin
      Color := RandomColorHeader;
      showcolorstatus(Color);
      //RepaintButtondAndStatus(Color);
    end;
  end;
end;

procedure Tf0.ckColorClick(Sender: TObject);
begin
  with tCheckBox(Sender) do begin
    Colorize := state = cbChecked;
  end;
end;

function tf0.RandomColorFrame: TColor;
begin
  Result := TColor($2AAAAAA or random($FFFFFF));
end;

function tf0.RandomColorHeader: TColor;
begin
  Result := TColor($2888888 or random($FFFFFF));
end;

function tf0.RandomColorDetail: TColor;
begin
  Result := TColor($2888888 or random($FFFFFF));
end;

//type
//  tmywinControl = class(TWinControl);

procedure tf0.CreateComponents;
const
  _TOP = 8; _HEIGHT = 22; _WIDTH = 75;
  function _CreateControl(CtlClass: TControlClass; const CtlName, CtlCap: string;
    Left: integer; Width: integer = _WIDTH; Top: integer = _TOP; Height: integer = _HEIGHT): TControl;
  begin
    Result := CtlClass.Create(Dashboard);
    Result.Name := CtlName;
    Result.Parent := Dashboard;
    if width = 0 then width := _width;
    if height = 0 then height := _height;
    Result.ShowHint := YES;
    Result.SetBounds(left, top, width, height);
    if (Result is tspinedit) then begin
      with tSpinEdit(Result) do begin
        Value := StrToIntDef(CtlCap, 1);
        MinValue := 1;
        MaxValue := MaxInt;
        // width := 60;
        // Value := random(5);
      end;
    end
    else if (Result is tedit) then
      tedit(Result).Text := CtlCap
    else begin
      tmyControl(Result).Caption := CtlCap;
      if Result is tlabel then with tlabel(Result) do begin
          WordWrap := TRUE;
        end
      else if Result is TSpeedButton then with TSpeedButton(Result) do begin
          btOpen := TSpeedButton(Result);
          btOpen.Flat := TRUE;
        end;
    end;
    Result.Visible := YES;
  end;

  function _CreateComponent(ComClass: TComponentClass; const CtlName, CtlCap: string;
    Left: integer; Width: integer = _WIDTH; Top: integer = _TOP; Height: integer = _HEIGHT): TComponent;
  begin
    Result := ComClass.Create(Self);
  end;

  //procedure SetMultiLineCaption(Ctl: TWinControl; const CRLF_Char: char = '|');
  //var
  //  bs: cardinal;
  //  cap: string;
  //begin
  //  if Ctl is TWinControl then with tmywinControl(Ctl) do begin
  //      cap := Caption;
  //      if pos(CRLF_CHAR, cap) > 0 then begin
  //        while pos(CRLF_CHAR, cap) > 1 do cap[pos(CRLF_CHAR, cap)] := ^J;
  //        Caption := cap;
  //        bs := GetWindowLong(handle, GWL_STYLE);
  //        SetWindowLong(handle, GWL_STYLE, bs or BS_MULTILINE);
  //      end;
  //    end;
  //end;

  procedure RecreateDashboard;
  begin
    Dashboard.Free;
    Dashboard := tPanel.Create(Self);
    with Dashboard do begin
      SetBounds(0, 0, Width, 38);
      BevelInner := bvRaised;
      BevelOuter := bvLowered;
      ParentColor := TRUE;
      OnClick := FramesAreaClicked;
      Align := alTop;
      Parent := Self;
    end;
    _CreateControl(tedit, 'edSubString', ' ', 36);

    exit;
    ///----------------------------------------------------------L---W---T--H--
    _CreateControl(tedit, 'edSubString', ' ', 36);
    _CreateControl(tedit, 'edReplacement', '[a space]', 212);
    _CreateControl(tLabel, '', 'Find:', 12, 0, 10);
    _CreateControl(tLabel, '', 'Replace'^J'with:', 170, 0, 4);
    _CreateControl(tCheckBox, 'ckIgnoreCase', 'Ignore|Case', 500, 55, 4, 30);
    _CreateControl(tLabel, '', 'Start'^J'Pos:', 300, 0, 4, 30);
    _CreateControl(tLabel, '', 'Loop'^J'Count:', 400, 0, 4, 30);
    _CreateControl(tSpinEdit, 'seStartPos', '1', 328, 65);
    _CreateControl(tSpinEdit, 'seLoopCount', '3', 440, 50);
    //_CreateControl(tColorButton, 'btOpen', 'OPEN',           112, 55,  8, 22);
    btOpen := TSpeedButton(
      _CreateControl(tSpeedButton, 'btOpen', 'OPEN...', 112, 55, 8, 22));
    _CreateControl(tCheckBox, 'ckColor', '()' {'COLORIZER'}, 560, 40);
    ///
  end;

  procedure RecreateStatusBar;
  var n:integer;
  begin
    StatusBar := TStatusBar.Create(Self);
    //StatusBar.SimplePanel := YES;
    StatusBar.Parent := Self;
    StatusBar.Top := Height;
    with StatusBar.Panels.Add do begin
      text := 'Progress';
      //width := width * 2;
      Alignment := taCenter;
    end;
    for n:=1 to 5 do
      with StatusBar.Panels.Add do begin
        //text := 'Contestant';
        width := width * 2;
        Alignment := taCenter;
      end;
  end;

  procedure RecreateScrollBox;
  begin
    ScrollBox := TScrollBox.Create(Self);
    //ScrollBox.AutoScroll := FALSE; //set this on later after form has maximized
    ScrollBox.BorderStyle := bsNoNe;
    ScrollBox.VertScrollBar.Smooth := TRUE;
    //ScrollBox.Align := alClient;
    ScrollBox.ALign := AlLeft;
    ScrollBox.Width := width - 10;
    with scrollbox do Anchors := Anchors + [akRight];
    ScrollBox.OnClick := FramesAreaClicked;
    ScrollBox.Parent := Self;
    ScrollBox.ParentFont := TRUE;
  end;

  procedure RecreateOtherComponents;
  begin
    OpenDialog.Free;
    OpenDialog := TOpenDialog.Create(Self);
    OpenDialog.FileName := 'test.txt';
  end;

  procedure FreeControls;
  var
    i: integer;
  begin
    for i := ControlCount - 1 downto 0 do begin
      with TMyControl(controls[i]) do
        if not (ClassType = TPanel) then //and not (ClassType = TStatusBar) //and not (ClassType = TSpeedButton) then
          free
        else
          ParentColor := YES;
    end;
  end;

  procedure ReassignControls;
    //var    ctl: Tcontrol;
  begin
    //ctl := ; nil;
    //if Ctl <> nil then
    SetMultiLineCaption(Dashboard.findChildControl('ckIgnoreCase') as twinControl);
    ckColor := Dashboard.findChildControl('ckColor') as tCheckbox;
    if ckColor <> nil then begin
      ckColor.Hint := '''Buble-Gummer''s'^J'Random Clr Picker';
      ckColor.OnClick := ckColorClick;
    end;
    // btOpen := Dashboard.FindChildControl('btOpen') as tSpeedButton; //tColorButton;
    if btOpen <> nil then
      btOpen.OnClick := btOpenClick;
  end;

  //procedure CreateButtons(

begin
  cxdfuncs.Self := Self;
  FreeControls;
  //RecreateDashboard;
  begin
    Dashboard := TPanel.Create(Self);
    Dashboard.Height := 1;
    Dashboard.BevelOuter := bvNone;
    Dashboard.Align := alTop;
    Dashboard.Parent := Self;
  end;
  ReassignControls;
  RecreateScrollBox;
  RecreateStatusBar;
  RecreateOtherComponents;

  CreateLabelNames; // margin / frames
  CreateCheckListBoxes;
  CreateCheckBoxes;
  CreateLabelProductReturns;
  //ShowGlobalSettings;
end;

type
  tmyhint = class(THintWindow)
    constructor Create(whoever: TComponent); override;
  end;

constructor Tmyhint.Create;
begin
  inherited Create(whoever);
  with Canvas do begin

    with Font do begin
      Name := 'Tahoma';
      Size := 13;
    end;
  end;
end;

procedure Tf0.init;
  procedure CreateOptionsForms;
  begin
    HintWindowClass := tmyhint;
    Application.HintHidePause := 10000;
    fFindOptions := TfFindOptions.Create(Application);
    //ShowGlobalSettings;
  end;

  procedure getSpeedButtonImages;
  begin
    try
      SpeedButton1.Glyph.LoadFromResourceName(hInstance, 'BMP_SETTINGS');
      SpeedButton2.Glyph.LoadFromResourceName(hInstance, 'BMP_PROCEED');
      sbStop.Glyph.LoadFromResourceName(hInstance, 'BMP_STOP');
      SpeedButton4.Glyph.LoadFromResourceName(hInstance, 'BMP_INFO');
    except
    end;
  end;

const
  DEFAULT_FORM_MINWIDTH = 400;
  DEFAULT_FORM_MAXWIDTH = 620;

  DEFAULT_FORM_MIN_HEIGHT = 400; //475;
  DEFAULT_FORM_MAX_HEIGHT = 640; //475;

  DEFAULT_FORM_WIDTH = DEFAULT_FORM_MAXWIDTH - 20;
  DEFAULT_FORM_HEIGHT = DEFAULT_FORM_MAX_HEIGHT; //475;

begin
  CreateOptionsForms;
  ForceCurrentDirectory := YES;
  Position := poScreenCenter;
  AutoScroll := FALSE;
  KeyPreview := YES;

  Width := DEFAULT_FORM_WIDTH;
  Height := DEFAULT_FORM_HEIGHT;
  Constraints.MaxWidth := DEFAULT_FORM_MAXWIDTH;
  Constraints.MinWidth := DEFAULT_FORM_MINWIDTH;
  Constraints.MinHeight := DEFAULT_FORM_MIN_HEIGHT;
  //Constraints.MaxHeight := DEFAULT_FORM_MAX_HEIGHT;
  OldColor := Color;

  CreateComponents;
  ShowGlobalSettings;
  getSpeedButtonImages;
  //WindowState := wsMaximized;
end;

procedure Tf0.FormCreate(Sender: TObject);
begin
  init;
end;

procedure tf0.ShowGlobalSettings; // display globalsettings
  function CheckBoxOf(const c: tContestant): tCheckBox;
  const
    GoForward = YES;
    CheckTabStop = FALSE;
    CheckParent = FALSE;
  var
    cn: tContestant;
  begin
    Result := CheckBox;
    if c > low(c) then
      for cn := succ(low(c)) to c do
        Result := TCheckBox(FindNextControl(TwinControl(Result), GoForward, CheckTabStop, CheckParent));
  end;
var
  c: TContestant; m: TMethode;
begin
  with GlobalSettings do begin
    for c := low(c) to high(c) do
      with ContestantCheckListBoxes[c] do begin
        for m := low(m) to high(m) do
          Checked[ord(m)] := m in CheckedMethodes[c];
        SyncCheckListBox(c, c in EnabledContestants, YES);
        CheckBoxOf(c).Checked := enabled;
      end;
  end;
end;

procedure tf0.StoreDisplayedSettings; // store displayed settings to globalsettings
var
  c: TContestant; m: TMethode;
begin
  with GlobalSettings do begin
    EnabledContestants := [];
    for c := low(c) to high(c) do
      with ContestantCheckListBoxes[c] do begin
        if Enabled then
          include(EnabledContestants, c);
        CheckedMethodes[c] := [];
        for m := low(m) to high(m) do
          if checked[ord(m)] then include(CheckedMethodes[c], m)
      end;
  end;
end;


procedure Tf0.btOpenClick(Sender: TObject);
const
  SCaseOption : array[boolean] of string = ('CaseSensitive', 'IgnoreCase');
var
  Strings: TStrings;
begin
  Strings := TStringList.Create;
  try
    try
      if Strings = nil then begin
      //EnumComponentProperties(OpenDialog, Strings);
      //EnumComponents(Self, Strings);
      //EnumControls(ScrollBox, Strings);
      //showmessage(Strings.Text);
      end;
      StoreDisplayedSettings;
      with fFindOptions do
        if ShowModal = mrOK then begin
          _FileName_ := '';
          case grLocation.ItemIndex of
            0: begin
                _FileName_ := cbFilename.Text;
                strings.LoadFromFile(_FileName_);
                _R_ := Strings.Text;
              end;
            else _R_ := Clipboard.Astext;
          end;
          _SubStr_ := cbFindSubstring.Text;
          _Replacement_ := cbReplacement.Text;
          _IgnoreCase_ := ckIgnoreCase.Checked;
          _CaseSensitive_ := not _IgnoreCase_;
          _StartPos_ := seStartPos.Value;
          _LoopCount_ := seLoopCount.Value;
          _SLength := length(_R_);
          _SubStrLength := length(_SubStr_);
        end;
        StatusBar.panels[1].Text := upperCase(ExtractFileName(_FileName_));
        StatusBar.panels[2].Text := _subStr_;
        StatusBar.panels[3].Text := _Replacement_;
        StatusBar.panels[4].Text := 'StartPos: '+ IntToStr(_StartPos_);
        StatusBar.panels[5].Text := SCaseOption[_IgnoreCase_];
    except
      _LoopCount_ := -1;
      //_S_ := ''; _R_ := '';
      //_SubStr_ := ''; _Replacement_ := '';
    end;
  finally
    Strings.Free;
  end;
end;

procedure Tf0.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = ^[then begin
    Key := #0;
    if not InProgress then Close
    else begin
      if not Broken then Broken := YES;
      InProgress := FALSE;
    end;
  end;
end;

procedure Tf0.CheckListBox1ClickCheck(Sender: TObject);
begin
  with tCheckListBox(Sender) do
    SyncContestantLabels(TContestant(tag), TMethode(itemIndex), TRUE, checked[itemIndex])
end;

//procedure tf0.EnumControls(Component: TComponent; Strings: TStrings);
//var
//  i: Integer;
//begin
//  if Component is TWinControl then
//    with Component as TWinControl do
//      for i := 0 to ControlCount - 1 do
//        with tMyControl(Controls[i]) do
//          Strings.Add(Caption + ' ' + Name + ': ' + ClassName)
//end;
//
// procedure tf0.EnumComponents(Component: TComponent; Strings: TStrings);
// var
//   i: Integer;
// begin
//   with Component do
//     for i := 0 to ComponentCount - 1 do
//       with Components[i] do
//         Strings.Add(Name + ': ' + ClassName)
// end;
//
// procedure tf0.EnumComponentProperties(Component: TComponent; Strings: TStrings);
// var
//   Count, Size, I: Integer;
//   List: PPropList;
//   PropInfo: PPropInfo;
//   PropOrEvent, PropValue: string;
// begin
//   Count := GetPropList(Component.ClassInfo, tkAny, nil);
//   Size := Count * SizeOf(Pointer);
//   GetMem(List, Size);
//   try
//     Count := GetPropList(Component.ClassInfo, tkAny, List);
//     for I := 0 to Count - 1 do begin
//       PropInfo := List^[I];
//       if PropInfo^.PropType^.Kind in tkMethods then
//         PropOrEvent := 'Event'
//       else
//         PropOrEvent := 'Property';
//
//       //D5: PropValue := VarToStr(GetPropValue(Component, PropInfo^.Name));
//       //D7: PropValue := (GetPropValue(Component, PropInfo^.Name));
//       Strings.Add(Format('[%s] %s: %s = %s', [PropOrEvent, PropInfo^.Name,
//         PropInfo^.PropType^.Name, PropValue]));
//     end;
//   finally
//     FreeMem(List);
//   end;
// end;

procedure Tf0.FormClick(Sender: TObject);
begin
  FramesAreaClicked(Sender);
end;

procedure Tf0.showcolorstatus(colour: TColor);
begin
  with StatusBar do
    //Color := Colour; //better be set outside
    //SimpleText := {ClassName+} 'Color: ' + inttohex(Colour, 8);
end;

procedure Tf0.HeaderControl1DrawSection(HeaderControl: THeaderControl;
  Section: THeaderSection; const Rect: TRect; Pressed: Boolean);
var
  i: integer;
begin
  with HeaderControl.Canvas do begin
    Brush.Color := Color;
    //if Pressed then Font.Color := clRed else Font.Color := clBlue;
    i := Section.Width - TextWidth(Section.Text);
    TextOut(Rect.Left + i div 2, Rect.Top + 2, Section.Text);
  end;
end;

procedure Tf0.HeaderControl1SectionClick(HeaderControl: THeaderControl; Section: THeaderSection);
var
  i: integer; //r: TReturn;
begin
  i := HeaderControl.Sections.Count - 1 - ord(high(TReturn));
  i := Section.Index - i;
  if i in [ord(low(Treturn))..ord(high(TReturn))] then
    ColumnAreaClicked(LabelTitles[TReturn(i)])
  else
    FramesAreaClicked(Self);
end;

procedure Tf0.sbSettingsClicked(Sender: TObject);
begin
  btOpenClick(Sender);
end;

procedure Tf0.SpeedButton4Click(Sender: TObject);
begin
  with TfrTeste.Create(Self) do begin
    showmodal;
    free;
  end;
  //
end;

procedure tf0.EnableControls(const enable: boolean);
var
  i: integer;
begin
  ScrollBox.Enabled := enable;
  with Dashboard do
    for i := ControlCount - 1 downto 0 do
      with Controls[i] do
        if Enabled <> enable then
          Enabled := enable;
  with Panel1 do
    for i := ControlCount - 1 downto 0 do
      with Controls[i] do
        if Enabled <> enable then
          Enabled := enable;
  with sbStop do
    if not Enabled then
      Enabled := TRUE;
end;

procedure tf0.SetInProgress(const processing: boolean);
begin
  EnableControls(not processing);
  KeyPreview := not (processing);
end;

procedure tf0.BreakUp(const breakit: boolean);
begin
  if fBroken <> breakit then begin
    fBroken := breakit;
  end;
  if fBroken then EnableControls(YES);
end;

procedure Tf0.sbStopClicked(Sender: TObject);
begin
  Broken := TRUE;
end;

function RankSort(Label1, Label2: pointer): integer;
var
  a, b: integer;

begin
  a := TLabel(Label1).tag;
  b := TLabel(Label2).tag;
  a := ProductReturnValues[rtTimeTotal, DecodeContestant(a), DecodeMethode(a)];
  b := ProductReturnValues[rtTimeTotal, DecodeContestant(b), DecodeMethode(b)];
  result := a - b;
end;

procedure tf0.GetStatistics;


const
  granularity = 1E7;
  //SLength: integer = 0;
  function tf0_GetTotalTicks(const Contestant: TContestant;
    methode: TMethode; out Return: integer): int64;
  var
    i: integer;
    tic, tac: int64;
  begin
    Result := 0;
    //if methode = mtReplaceFile then begin
    //  _RFilename_ := dummyfilename(Contestant);
    //  ShowStatus([idsWorkingFile], [_RFileName_]);
    //end;
    with ContestantFunctions[Contestant] do
      for i := 1 to _LoopCount_ do begin
        //ShowStatus([idsLoopCounter, idsContestant, idsMethod],
        //  ['loop: ' + intoStr(i), ContestantsName[Contestant], MethodesName[methode]]);
        SyncContestantLabels(Contestant, methode, stInProgress);
        ShowStatus([idsLoopCounter], ['loop: ' + intoStr(i)], YES);
        if Broken or ((GetKeyState(VK_ESCAPE) and $80) = $80) then Break;
        _S_ := _R_;
        //setlength(_S_, length(_R_));
        QueryPerformanceCounter(tic);
        case methode of
          mtPos: Return := fnPos;
          mtCount: Return := fnCount;
          mtReplace: Return := length(fnReplace);
          mtPosFile: Return := fnPosFile;
          mtCountFile: Return := fnCountFile;
          mtReplaceFile: begin
              if FileExists(_RFileName_) then DeleteFile(_RFilename_);
              CopyFile(PChar(_Filename_), PChar(_RFileName_), FALSE);
              QueryPerformanceCounter(tic);
              Return := fnReplaceFile; //fnReplaceFile;
            end;
          else
            QueryPerformanceCounter(tic);
        end;
        QueryPerformanceCounter(tac);
        SyncContestantLabels(Contestant, methode, stChecked);
        //Result := Result - tic + tac;
        inc(Result, tac - tic);
      end;
    //if FileExists(_RFileName_) and not fFindOptions.ckKeepFiles.checked then
    //  DeleteFile(_RFilename_);
  end;

  procedure DrawFormattedLabel(const r: TReturn; const c: TContestant; const m: TMethode);
  const
    rightspace = '   ';
    rightspace2 = rightspace + rightspace;
    slilit = '~' + rightspace2;
  begin
    case r of
      rtResult: LabelProductReturns[r, c, m].Caption :=
        blocks(ProductReturnValues[r, c, m], '.') + rightspace2;
      rtTimeTotal..rtPerfRatio: //begin
          with LabelProductReturns[r, c, m] do begin
            if ProductReturnValues[rtResult, c, m] < 0 then
              Caption := slilit
            else
              Caption := blocks(ProductReturnValues[r, c, m], '.') + rightspace;
            if r = rtPerfRatio then Font.Color := clrFGPerfRatio;
        end;
      else
        raise exception.create('error unknown return type!')
    end;
  end;

  procedure DrawReturns(const c: TContestant; const m: TMethode;
    const Result: integer; const ticks: int64);

  var nanosec, avg, perf: integer; r: TReturn; ext: extended;
  begin
    ext := ticks * granularity;
    nanosec := round(ext / tickHz);
    avg := round(ext / tickHz / _LoopCount_);
    if (ticks > 0) and (result >= 0) then begin
      ext := _LoopCount_ * tickHz / granularity * 1000;
      if (m = mtPos) and (Result > 0) then
        perf := round((ext * Result) / ticks)
      else
        perf := round((ext * _SLength) / ticks)
    end
    else perf := -1;


    ProductReturnValues[rtResult, c, m] := Result;
    ProductReturnValues[rtTimeTotal, c, m] := nanosec;
    ProductReturnValues[rtTimeAverage, c, m] := avg;
    ProductReturnValues[rtPerfRatio, c, m] := perf;

    for r := rtResult to rtPerfRatio do
      DrawFormattedLabel(r, c, m);
  end;

  procedure ComputeRanks;
  var
    c: TContestant; m: TMethode;
    i: integer;
    List: tlist;
    redon: boolean;
  begin
    List := TList.Create;
    try
      for m := low(m) to high(m) do begin
        List.Clear;
        for c := low(c) to high(c) do begin
          //with List do begin
          //for cl := low(cl) to high(cl) do
          if (ProductReturnValues[rtPerfRatio, c, m] > 0) and LabelProductReturns[rtPerfRatio, c, m].enabled then
            List.Add(LabelProductReturns[rtPerfRatio, c, m]);
        end;
        if List.Count = 1 then begin
          with LabelProductReturns[rtRank, DecodeContestant(TLabel(List[0]).Tag), m] do begin
            Caption := '-';
            Font.Color := lcfChecked;
          end;
          continue;
        end
        else begin
          begin
            List.Sort(RankSort);
            redon := TRUE;
            //s := '';
            //for i := 0 to List.Count - 1 do begin
            //  s := s + ContestantsName[decodeContestant(tlabel(List[i]).tag)] + ^j;
            //end;
            //  showmessage(s);
            for i := 0 to List.Count - 1 do begin
          //cl := DecodeContestant(TLabel(List[i]).Tag);
          //lb := LabelProductReturns[rtRank, cl, m];
          //if lb.Enabled then
          //lb.Caption := intoStr(i + 1);
              with LabelProductReturns[rtRank, DecodeContestant(TLabel(List[i]).Tag), m] do begin
                if (i = 0) then Caption := 'best'
                else
                  Caption := intoStr(i + 1);
                with Font do
                  if redon then
                    if ContestantCheckListBoxes[DecodeContestant(Tag)].checked[ord(m)] then begin
                      Color := lcfFastestChecked;
                      redon := FALSE;
                    end
                    else Color := lcfFastestUnchecked
                  else Color := lcfChecked
              end;
            end;
          end;
        end;
      end;
    finally
      List.free;
    end;
  end;

  function CheckInsanity: tModalResult; begin
    if (_LoopCount_ > 0) and (TRUE) and (TRUE) then
      Result := mrOK
    else begin
      showmessage('please confirm the settings first...');
      Result := mrNone;
    end;
  end;

  function dummyfilename(contestant: TContestant): string;
  const _ext = '.tmp';
  begin
    Result := ContestantsName[Contestant] + '_' + IntToHex(random(MaxInt), 8) + _ext;
    while fileexists(Result) do
      Result := ContestantsName[Contestant] + '_' + IntToHex(random(MaxInt), 8) + _ext;
  end;
var
  c: TContestant; m: TMethode; mx: TMethodes;
  out: integer;
  ticks: int64;
begin
  if CheckInsanity <> mrOk then
  else begin
    Broken := FALSE;
    InProgress := YES;
    try
      QueryPerformanceFrequency(tickHz);
      for c := low(c) to high(c) do begin
        mx := [];
        with ContestantCheckListBoxes[c] do
          if enabled then
            for m := low(m) to high(m) do
              if ItemEnabled[ord(m)] and Checked[ord(m)] then
                include(mx, m);

        for m := low(m) to high(m) do begin
          Application.ProcessMessages;
          if Broken then break;
          if m in mx then begin
            if m = mtReplaceFile then begin
              _RFilename_ := dummyfilename(c);
              ShowStatus([idsWorkingFile], [_RFileName_]);
            end;
            ticks := tf0_GetTotalTicks(c, m, out);
            DrawReturns(c, m, out, ticks);
          end;
        end;
      end;
      ComputeRanks;
    finally
      InProgress := FALSE;
    end;
  end;
end;

procedure Tf0.sbProceedClicked(Sender: TObject);
const
  Status: array[boolean] of string = ('Done', 'Aborted');
begin
  ShowStatus([idsProgress], ['processing...']);
  GetStatistics;
  ShowStatus([idsProgress], [Status[Broken]])
end;

procedure tf0.ShowStatus(const indexes: array of byte;
  const Messages: array of string; const Referesh: boolean = FALSE);
var i: integer;
begin
  with StatusBar do
    for i := 0 to high(indexes) do
      if i < Panels.Count then begin
        if i < length(Messages) then
          Panels[i].text := Messages[i]
      end
      else
        if length(Messages) > 0 then
          SimpleText := Messages[0];
  if Referesh then Application.ProcessMessages;
end;

procedure Tf0.CheckListBox1Exit(Sender: TObject);
begin
  with tCheckListBox(sender) do if ItemIndex >= 0 then itemindex := -1
end;

initialization
  randomize;

end.

